*==============================================================
*--Programm		: OSHANDEL.PRG
*--Ersteller	: Frank Beitelmann
*--Erstelldatum	: unbekannt
*--Zweck		: HauptProgramm zum Aufruf von OSHANDEL selbst
*--Parameter	: cCommand - "NE"				- NO EVENTS fr die Entwicklung selbst
*--				: 			 "CALL,%PROGRAMM%"	- RUFT DIREKT ein Formular auf
*--Rckgabe		: 
*--nderungen	: 28.05.2003 - FB - CONFIG.FPW gendert - PROGWORK,TMPWORK,usw. Verzeichnisse sollen LOKAL liegen
*--				  16.08.2003 - FB - Es knnen nun verschiedene NEBENPRODUKTE mit angegeben werden
*--									Zur Zeit sind "KASSE","GXCHANGESERVER","GXCHANGECLIENT","GXCHANGETEST" eingebaut
*--									Hier MSSEN wir noch die gekauften MODULE abfragen und DIREKT eintragen
*--				  27.08.2003 - FB - Fr uns als Entwickler soll immer der Korrekte PFAD eingetragen werden
*--				  03.11.2003 - FB - Es soll bei Fehlern direkt beendet werden, ohne KEYGENERATOR
*===============================================================

LPARAMETERS cCommand, lcNEBENPRODUKT
LOCAL cForm, lcSystemDir, lnSystemDirLen &&,cProgPath
PUBLIC _AddonRegGroup
PUBLIC ploshandel_exit

*lnGenutzter_speicher =   27262976 &&20 Megabyte &&val(sys(3050,1))/3 ein drittel des SYSTEMSPEICHERS
*=sys(3050,1,lnGenutzter_speicher)
*lnGenutzter_speicher =   47185920 &&47 Megabyte &&val(sys(3050,2))/3 &&ein drittel des SYSTEMSPEICHERS
*=sys(3050,2,lnGenutzter_speicher)

DECLARE INTEGER GetSystemDirectory in WIN32API STRING @cBuffer, INTEGER uSize 

_screen.visible=.f.
_screen.windowstate = 2  && maximiert

#DEFINE HKEY_CLASSES_ROOT           -2147483648  && BITSET(0,31)
#DEFINE HKEY_CURRENT_USER           -2147483647  && BITSET(0,31)+1
#DEFINE HKEY_LOCAL_MACHINE          -2147483646  && BITSET(0,31)+2
#DEFINE HKEY_USERS                  -2147483645  && BITSET(0,31)+3


*MD: Druckprobleme bei HoBa, wird genutzt in reports.frmprint.printlist()
DECLARE _fpreset IN msvcrt20.dll &&Floating Point reset

&&cProgPath  = ""
_cAddonRegGroup  = ""     && Zusatzkennzeichen zur Registry Gruppe - J.U. - 2000-10-19

lcSystemDir    = space(100)
lnSystemDirlen = GetSystemDirectory(@lcSystemDir,100)
lcSystemDir    = Substr(lcSystemDir,1,lnSystemDirlen)
*MB 28.05.2003 - PROGWORK,TMPWORK,usw. Verzeichnisse sollen LOKAL liegen
IF !DIRECTORY("TEMP")
	MKDIR TEMP
ENDIF

ploshandel_exit = .t.

set procedure to .\progs\tools
*MB 27.08.2003 - Fr uns als entwickler soll immer der Korrekte PFAD eingetragen werden
IF _vfp.StartMode  = 0
	SET PATH TO forms;fwk\libs\;libs;progs;fwk\graphics;graphics;graphics\buttons;graphics\icons;graphics\large;reports
ELSE
	set path to progs;forms;menus;reports
ENDIF

DO WHILE ploshandel_exit
	cForm =""
	if empty(cCommand)
	   cCommand=""
	else                            && J.U. - 2000-10-19 - Erlaubt die Verwendung von mehreren Registry Schlsseln
	   cCommand=upper(cCommand)
	   if csv2String(cCommand)=1
	      if alltrim(csv2String(cCommand,1))="INIT" or alltrim(csv2String(cCommand,1))="NE" or alltrim(csv2String(cCommand,1))="NOEVENTS" 
	         _cAddonRegGroup = ""
	         cCommand  = alltrim(csv2String(cCommand,1))
	      else
	         _cAddonRegGroup = alltrim(csv2String(cCommand,1))
	         cCommand  = ""
	      endif
	   else
	     IF alltrim(csv2String(cCommand,1))="CALL"
	       IF alltrim(csv2String(cCommand,1)) = "CALL" and csv2String(cCommand) >= 2
	         cForm    = alltrim(csv2String(cCommand,2))
	         cCommand = alltrim(csv2String(cCommand,1))
	       ENDIF
	     ELSE
	        _cAddonRegGroup = alltrim(csv2String(cCommand,1))
	        cCommand  = alltrim(csv2String(cCommand,2))
	     ENDIF
	   endif
	endif

	set talk off
	release goApp
	public goApp
	ON ERROR do ErrorHandler in oshandel with ERROR(),PROGRAM(),LINENO(), MESSAGE(1)
	on SHUTDOWN do OnShutdown in oshandel
	on key

	IF cCommand="INIT"
	   Check_Registry(_cAddonRegGroup,"INIT")
	ENDIF

	SAVE TO alltrim(sys(2023))+"\OSHANDEL.1"
	IF Check_Registry(_cAddonRegGroup)
		
		*MD: 02.03.04: Abprfung ob gerade ein Update gefahren wird:
		IF !VFP_Update()
			DO cleanup
			ploshandel_exit=.f.
			EXIT
		ENDIF
		
		*MB ich frage mich immer noch, warum man die VARIABLEN ausliest oder Speichert!?

		IF FILE(alltrim(sys(2023))+"\OSHANDEL.1")
			RESTORE FROM alltrim(sys(2023))+"\OSHANDEL.1" ADDITIVE
			ERASE alltrim(sys(2023))+"\OSHANDEL.1"
		ENDIF
		IF FILE(ALLTRIM(sys(2023))+"\OSHANDEL.2")
			RESTORE FROM ALLTRIM(sys(2023))+"\OSHANDEL.2"  ADDITIVE
			ERASE ALLTRIM(sys(2023))+"\OSHANDEL.2"
		ENDIF
		
		goApp=newobject("frmappl",".\libs\mainappl")
		goApp.cTempDir = alltrim(upper(sys(2023)))
		*Welches List and Label wird genutzt?
		DO CASE
		*MB 16.08.2003 - Wir haben noch kein List and Label 9 im Einsatz
		
**		CASE file(lcSystemDir+'\cmll10.dll')
**			_include = ".\progs\cmbtl10.h"
**			do ".\progs\cmbtl10"       && Combit List & Label 10 - DEFINES setzen - F.B. - 2005-05-04
		*CASE file(lcSystemDir+'\cm32l9.dll')
			*_include = ".\progs\cmbtl9.h"
			*do ".\progs\cmbtl9"       && Combit List & Label 9 - DEFINES setzen - M.P. - 2000-10-30
		CASE file(lcSystemDir+'\cm32l8.dll')
			#INCLUDE ".\progs\cmbtl8.h"
			do ".\progs\cmbtl8"       && Combit List & Label 8 - DEFINES setzen - M.P. - 2000-10-30
		OTHERWISE
			do ".\progs\cmbtl7"       && Combit List & Label 7 - DEFINES setzen - M.P. - 2000-10-30
		ENDCASE
		
		*Standard ist
		goApp.setcaption("OS - Handel")
		goApp.startupmenu="trdmain"
		*MD/MB wir wollen gleich die NEBENPRODUKTE KASSE,GXCHANGE mit aufrufen knnen
		IF !EMPTY(lcNEBENPRODUKT)
			lcNEBENPRODUKT=UPPER(ALLTRIM(lcNEBENPRODUKT))
			DO CASE
			CASE lcNEBENPRODUKT=="KASSE"
				goApp.setcaption("OS - Buchhandel Cash")
				goApp.startupmenu="cshmain"
				cForm = "FRMC010"
			CASE LEFT(lcNEBENPRODUKT,8)=="GXCHANGE"
				IF lcNEBENPRODUKT == "GXCHANGESERVER"
					cForm = "FRMXCHS"
				ENDIF
				IF lcNEBENPRODUKT == "GXCHANGECLIENT"
	       			cForm = "FRMXCHC"
				ENDIF
			ENDCASE
		ENDIF
		*Produkt/Nebenprodukt initialisierung abgeschlossen

		IF cCommand="NOEVENTS" or cCommand="NE"
			goApp.startup("NOEVENTS")
			EXIT
		ELSE
			ploshandel_exit = .t.
			set sysmenu to
			IF (cCommand  = "CALL" .or. !EMPTY(lcNEBENPRODUKT)) and not empty(cForm)
				goapp.cstartform = cForm
			ENDIF
			goApp.startup
			IF ploshandel_exit
				*CLEAR ALL
				do cleanup
				exit
			ELSE
				do cleanup
			ENDIF
		ENDIF
	ELSE
		=messagebox("Bei der berprfung der Registry Eintrge ist ein Fehler aufgetreten."+chr(13)+;
					"Das Programm wird beendet!"+chr(13)+;
					"An Error occured while checking Registry entries."+chr(13)+;
					"The program will be aborted",16)
		DO cleanup
		ploshandel_exit=.f.
		EXIT
	ENDIF
ENDDO

PROCEDURE OnShutdown
  IF vartype(goApp)="O"
    IF goapp.onshutdown()
       do cleanup
    ENDIF
  ENDIF
RETURN


PROCEDURE cleanup
  ON ERROR
  ON SHUTDOWN
  SET CLASSLIB TO
  SET PATH TO
  SET STATUS BAR ON
  CLOSE ALL
  POP MENU _msysmenu
  RELEASE ALL
  RELEASE DLLS
  CLEAR PROGRAM
RETURN


* ################################################################################# *
*  REGISTRY EINTRAG ERMITTELN UND FALLS NOETIG NEU ANLEGEN                          *
* ################################################################################# *
PROCEDURE Check_Registry
LPARAMETERS tcGroup, tcParam
LOCAL llok, llregistry, lcDataPath, lcProgValue, lcUpdateValue, lcCommonValue, lcMetaValue
   llok       = .T.
   llregistry = .T.
   
   RegRoot              = HKEY_LOCAL_MACHINE 
   RegGroup             = "Software\P30\MultiConverter"

&&   if tcParam<>"INIT" or tcParam<>"NE" or tcParam<>"NOEVENTS"   && wenn keines der vordefinierten Parameter genutzt wirde, wird der Programmschlssel ergnzt!
      RegGroup = RegGroup+tcGroup
&&   endif
   
   RegPrgN_ProgKey      = "ProgramPath"
   RegPrgN_ProgValue    = ""
   lcProgValue          = ""

   RegPrgN_UpdateKey    = "UpdatePath"
   RegPrgN_UpdateValue  = ""
   lcUpdateValue        = ""
   
   RegPrgN_CommonKey    = "CommonPath"
   RegPrgN_CommonValue  = ""
   lcCommonValue        = ""

   RegPrgN_MetaKey      = "MetaPath"
   RegPrgN_MetaValue    = ""
   lcMetaValue          = ""
   
   IF VARTYPE(oregistry)<>"O"
      oregistry=newobject("registry",".\fwk\libs\Registry.vcx")
   ENDIF
   
   IF VARTYPE(tcParam)<>"C"
      tcParam = ""
   ENDIF

   IF (not oregistry.iskey(RegGroup,RegRoot)) or ;
      oregistry.getregkey(RegPrgN_ProgKey,@lcProgValue,RegGroup,RegRoot)<>0 or ;
      oregistry.getregkey(RegPrgN_UpdateKey,@lcUpdateValue,RegGroup,RegRoot)<>0 or ;
      oregistry.getregkey(RegPrgN_CommonKey,@lcCommonValue,RegGroup,RegRoot)<>0 or ;
      oregistry.getregkey(RegPrgN_MetaKey,@lcMetaValue,RegGroup,RegRoot)<>0 or ;
      tcParam="INIT"    && Finde Registry Eintrag

      llregistry=.F.
      IF oregistry.openkey(RegGroup,RegRoot,.t.)<>0
         llok=.F.
      ENDIF
   ELSE   && Prfe die bermittelten Registry Pfad-Eintrge...
      IF empty(lcProgValue) or empty(lcUpdateValue) or empty(lcCommonValue) or empty(lcMetaValue)
         llregistry=Check_Registry("INIT")          && Registry Eintrag fehlerhaft - Eintrge neu schreiben
      ELSE
         * ------------------------------- *
         *  COMMON-VERZEICHNIS PRFEN      * 
         * ------------------------------- *
         IF FILE(lcCommonValue+"\MAND.DBF")
            * ------------------------------- *
            *  META-VERZEICHNIS PRFEN        * 
            * ------------------------------- *
            IF NOT FILE(lcMetaValue+"\CODES.DBF")
               llregistry=.F.    && Registry Eintrag fehlerhaft - Eintrge neu schreiben
            ENDIF

            * ------------------------------- *
            *  PROGRAM-VERZEICHNIS PRFEN     * 
            * ------------------------------- *
            IF NOT lcProgValue=substr(lcCommonValue,1,AT("\DATA",UPPER(lcCommonValue))-1)
               llregistry=.F.    && Registry Eintrag fehlerhaft - Eintrge neu schreiben
            ENDIF
            
            * ------------------------------- *
            *  UPDATE-VERZEICHNIS PRFEN      * 
            * ------------------------------- *
            IF NOT lcUpdateValue=strtran(lcCommonValue,substr(lcCommonValue,AT("\DATA",UPPER(lcCommonValue)),LEN(lcCommonValue)),"\UPDATE")
               llregistry=.F.    && Registry Eintrag fehlerhaft - Eintrge neu schreiben
            ENDIF
         ELSE
            llregistry=.F.       && Registry Eintrag fehlerhaft - Eintrge neu schreiben
         ENDIF

         IF NOT llregistry   && llregistry=false
            llregistry=Check_Registry("INIT")    && Registry Eintrag fehlerhaft - Eintrge neu schreiben
         ENDIF
         
      ENDIF
   ENDIF

   * ------------------------------------- *
   *  REGISTRYEINTRGE NEU SCHREIBEN       * 
   * ------------------------------------- *
   IF ((not llregistry) and llok)       && Fehlender Registry Eintrag oder neue Initialisierung
      IF oregistry.getregkey(RegPrgN_CommonKey,@lcDataPath,RegGroup,RegRoot)<>0
         _screen.visible=.t.
         *MB 03.11.2003 - Es soll bei Fehlern direkt beendet werden, ohne KEYGENERATOR
         *lcDataPath=JUSTPATH(UPPER(LOCFILE("MAND.DBF","Tabelle:DBF","Bitte das GBO-Trade Verzeichnis COMMON whlen!"))) && Wenn Eintrag nicht vorhanden -> Pfad ermitteln
         lcDataPath=UPPER(JUSTPATH(GETFILE("DBF","Mand.dbf","Whlen",0,"Bitte aus dem OS-Handel Verzeichnis COMMON\MAND.DBF whlen!")))
         _screen.visible=.f.
      ELSE  && Registry Eintrag auslesbar, aber falsch...
         _screen.visible=.t.
         *MB 03.11.2003 - Es soll bei Fehlern direkt beendet werden, ohne KEYGENERATOR
         lcDataPath=UPPER(JUSTPATH(GETFILE("DBF","Mand.dbf","Whlen",0,"Bitte aus dem OS-Handel Verzeichnis COMMON\MAND.DBF whlen!")))
         *lcDataPath=JUSTPATH(UPPER(locfile("MAND.DBF","Tabelle:DBF","Bitte das GBO-Trade Verzeichnis COMMON whlen!"))) && Wenn falscher Eintrag vorhanden -> Pfad ermitteln
         _screen.visible=.f.
      ENDIF
      IF empty(lcDataPath) .or. !FILE(ADDBS(lcDataPath)+"MAND.DBF") && kein Pfad vorhanden....
         llok = .F.
      ELSE   && Pfad vorhanden....
         llok = .T.
         RegPrgN_CommonValue = lcDataPath
         RegPrgN_MetaValue   = strtran(lcDataPath,"\COMMON","\META")
         
         RegPrgN_ProgValue   = substr(lcDataPath,1,RAT("\DATA",lcDataPath)-1)
         RegPrgN_UpdateValue = RegPrgN_ProgValue+"\UPDATE"
         
         IF tcParam="INIT" or oregistry.getregkey(RegPrgN_ProgKey,@lcProgValue,RegGroup,RegRoot)<>0
            IF oregistry.setregkey(RegPrgN_ProgKey,RegPrgN_ProgValue,RegGroup,RegRoot)<>0       && Programm Pfad
               llok=.F.
            ENDIF
         ENDIF
         
         IF tcParam="INIT" or oregistry.getregkey(RegPrgN_UpdateKey,@lcUpdateValue,RegGroup,RegRoot)<>0         
            IF oregistry.setregkey(RegPrgN_UpdateKey,RegPrgN_UpdateValue,RegGroup,RegRoot)<>0   && Update Pfad
               llok=.F.
            ENDIF
         ENDIF
         
         IF tcParam="INIT" or oregistry.getregkey(RegPrgN_CommonKey,@lcCommonValue,RegGroup,RegRoot)<>0
            IF oregistry.setregkey(RegPrgN_CommonKey,RegPrgN_CommonValue,RegGroup,RegRoot)<>0   && Common Pfad
               llok=.F.
            ENDIF
         ENDIF
         
         IF tcParam="INIT" or oregistry.getregkey(RegPrgN_MetaKey,@lcMetaValue,RegGroup,RegRoot)<>0         
            IF oregistry.setregkey(RegPrgN_MetaKey,RegPrgN_MetaValue,RegGroup,RegRoot)<>0       && Meta Pfad
               llok=.F.
            ENDIF
         ENDIF
      ENDIF
   ENDIF  && Keys anlegen

   * ------------------------------------- *
   *  NACH TUPDATE SUCHEN                  * 
   * ------------------------------------- *
   llok=llok and Check_CompUpdate("MULTICONV_UPDATE.EXE",tcGroup)
   
   * ------------------------------------- *
   *  NACH UPDATE SUCHEN                   * 
   * ------------------------------------- *
   && llok=llok and Check_PrgUpdate("OSHANDEL.EXE",tcGroup)
   
RETURN(llok)   && END CHECK_REGISTRY
   
* ################################################################################# *
*  NACH TUPDATE SUCHEN UND FALLS NEUE VERSION VORHANDEN AUSFHREN                   *
* ################################################################################# *

PROCEDURE Check_CompUpdate
LPARAMETERS tcupdfile, tcGroup
LOCAL llok, lcupdversion, lcinstversion, lcoldproc, lcupdpath, lcexeccommand, lcRegGroup, lcProgPath, llTUPDATE
LOCAL lcUpdExe
   llok          = .T.
   llTUPDATE     = .F.
   lcinstversion = ""
   lcupdversion  = ""
   lcoldproc     = SET("PROCEDURE")
   lcupdpath     = ""
   lcprogpath    = ""
   lcexeccommand = ""
   RegGroup      = "Software\P30\MultiConverter"
&&   if tcParam<>"INIT" or tcParam<>"NE" or tcParam<>"NOEVENTS"   && wenn keines der vordefinierten Parameter genutzt wirde, wird der Programmschlssel ergnzt!
      RegGroup = RegGroup+tcGroup
&&   endif
   
   IF VARTYPE(oregistry)<>"O"
      oregistry=newobject("registry",".\fwk\libs\Registry.vcx")
   ENDIF

   IF oregistry.iskey(RegGroup,HKEY_LOCAL_MACHINE)
      IF oregistry.getregkey("UpdatePath",@lcupdpath,RegGroup,HKEY_LOCAL_MACHINE)<>0
         llok=.F.
      ELSE
         IF NOT EMPTY(lcupdpath)
            IF NOT RAT("\",lcupdpath)=len(lcupdpath)
               lcupdpath=lcupdpath+"\"
            ENDIF
         ELSE
            llok=.F.
         ENDIF
      ENDIF && Get UpdatePath 
      IF oregistry.getregkey("ProgramPath",@lcprogpath,RegGroup,HKEY_LOCAL_MACHINE)<>0
         llok=.F.
      ELSE
         IF NOT EMPTY(lcprogpath)
            IF NOT RAT("\",lcprogpath)=len(lcprogpath)
               lcprogpath=lcprogpath+"\"
            ENDIF
         ELSE
            llok=.F.
         ENDIF
      ENDIF && Get ProgramPath 
   ELSE  && Kein Key vorhanden
      llok=.F.
   ENDIF

   IF llok
      IF FILE(lcupdpath+tcupdfile)

         lcVersionFile = ALLTRIM(SUBSTR(tcupdfile,1,atc(".",tcupdfile)))+"VSI"

         IF FILE(lcupdpath+lcVersionFile)
            lcupdVersion = ALLTRIM(FileToStr(lcupdpath+lcVersionFile))
            lcAktVerz = ALLTRIM(sys(5))+ALLTRIM(sys(2003))+"\"
            IF FILE(lcAktVerz+lcVersionFile)
               lcAktVersion = ALLTRIM(FileToStr(lcAktVerz+lcVersionFile))
               IF lcAktVersion < lcUpdVersion
                  llTUPDATE = .T.
               ENDIF
            ELSE
               llTUPDATE = .T.
            ENDIF
            
            IF llTUPDATE
               StrToFile(lcUpdVersion, lcAktVerz+lcVersionFile)
               lcExecCommand = lcupdpath+tcupdfile
               ON SHUTDOWN
               RUN /N &lcexeccommand
               clear events
               QUIT
               QUIT
            ENDIF

         ENDIF

      ENDIF
   ENDIF
RETURN(llok)   && END CHECK_COMPUPDATE


   
* ################################################################################# *
*  NACH UPDATE SUCHEN UND FALLS NEUE VERSION VORHANDEN KOPIEREN                     *
* ################################################################################# *
PROCEDURE Check_PrgUpdate
LPARAMETERS tcupdfile, tcGroup
LOCAL llok, lcupdversion, lcinstversion, lcoldproc, lcupdpath, lcexeccommand, lcRegGroup, lcProgPath
LOCAL lcUpdExe

*===============================================================
*--Programm		: OSHANDEL.PRG
*--Ersteller	: Frank Beitelmann
*--Erstelldatum	: unbekannt
*--Zweck		: Schaut nach einem UPDATE und holt dieses auf den LOKALEN PC
*--				  ACHTUNG! Es wird die .EXE nur geholt, wenn eine .UPD vorhanden ist, die die Version beeinhaltet
*--Parameter	: tcupdfile - MUSS - Welche EXE soll upgedated werden?
*--				  tcGroup	- KANN - 
*--Rckgabe		: LOGISCH	- UPDATE vorhanden
*--nderungen	: 28.05.2003 - MB - Es muss fr UPDATES nun eine DATEI NAMENS tcupdfile.upd liegen, in der die Version steht
*===============================================================

   llok          = .T.
   lcinstversion = ""
   lcupdversion  = ""
   lcoldproc     = SET("PROCEDURE")
   lcupdpath     = ""
   lcprogpath    = ""
   lcexeccommand = ""
   RegGroup      = "Software\P30\MultiConverter"
&&   if tcParam<>"INIT" or tcParam<>"NE" or tcParam<>"NOEVENTS"   && wenn keines der vordefinierten Parameter genutzt wirde, wird der Programmschlssel ergnzt!
      RegGroup = RegGroup+tcGroup
&&   endif
   
   IF VARTYPE(oregistry)<>"O"
      oregistry=newobject("registry",".\fwk\libs\Registry.vcx")
   ENDIF

   IF oregistry.iskey(RegGroup,HKEY_LOCAL_MACHINE)
      IF oregistry.getregkey("UpdatePath",@lcupdpath,RegGroup,HKEY_LOCAL_MACHINE)<>0
         llok=.F.
      ELSE
         IF NOT EMPTY(lcupdpath)
            IF NOT RAT("\",lcupdpath)=len(lcupdpath)
               lcupdpath=lcupdpath+"\"
            ENDIF
         ELSE
            llok=.F.
         ENDIF
      ENDIF && Get UpdatePath 
      IF oregistry.getregkey("ProgramPath",@lcprogpath,RegGroup,HKEY_LOCAL_MACHINE)<>0
         llok=.F.
      ELSE
         IF NOT EMPTY(lcprogpath)
            IF NOT RAT("\",lcprogpath)=len(lcprogpath)
               lcprogpath=lcprogpath+"\"
            ENDIF
         ELSE
            llok=.F.
         ENDIF
      ENDIF && Get ProgramPath 
   ELSE  && Kein Key vorhanden
      llok=.F.
   ENDIF

   IF llok
      IF FILE(lcupdpath+tcupdfile)

         
         * ---------------------- *
         *   VISUAL_FAKSTRU_DO?   *
         * ---------------------- *
         
         IF FILE(lcprogpath + "VISUAL_FAKSTRU_DO.EXE")
            DELETE FILE lcprogpath + "VISUAL_FAKSTRU_DO.EXE"
         ENDIF

         * ---------------------- *
         *   GESTARTETE VERSION   *
         * ---------------------- *
         IF VARTYPE(oaktversion)<>"O"
            oaktversion = NEWOBJECT("_version","libs\mainappl.vcx")
         ENDIF
         lcinstversion = substr(alltrim(oaktversion.version),12,8)
         
         SAVE TO ALLTRIM(SYS(2023))+"\OSHANDEL.3"
         CLEAR ALL
         IF FILE(ALLTRIM(SYS(2023))+"\OSHANDEL.3")
            RESTORE FROM ALLTRIM(SYS(2023))+"\OSHANDEL.3" ADDITIVE
            ERASE ALLTRIM(SYS(2023))+"\OSHANDEL.3"
         ENDIF
         
         * ---------------------- *
         *     UPDATE VERSION     *
         * ---------------------- *
         *MB 28.05.2003 - Es muss fr UPDATES nun eine DATEI NAMENS tcupdfile.upd liegen, in der die Version steht
         
         IF FILE(lcupdpath+JUSTSTEM(tcupdfile)+".UPD")
         	lcupdversion = FILETOSTR(lcupdpath+JUSTSTEM(tcupdfile)+".UPD")
         ELSE
         	*MB 28.05.2003  -So war es vor den UPD dateien
	         IF VARTYPE(oupdversion)<>"O"
	            oupdversion = NEWOBJECT("_VERSION","MAINAPPL",ALLTRIM(lcupdpath+tcupdfile))
	         ENDIF
	         lcupdversion = substr(alltrim(oupdversion.version),12,8)
	         RELEASE oupdversion
	     ENDIF
         SAVE TO ALLTRIM(sys(2023))+"\OSHANDEL.2"
         CLEAR ALL
         RESTORE FROM ALLTRIM(sys(2023))+"\OSHANDEL.2" ADDITIVE

*!*	         * ---------------------- *
*!*	         *     UPDATE VERSION     *
*!*	         * ---------------------- *
*!*	         lcupdversion = lcinstversion
*!*	         lcUpdExe = filetostr(lcupdpath+tcupdfile)
*!*	         IF not empty(lcUpdExe)
*!*	            lnpos = ATC("//"+"VERSION"+"//",lcUpdExe)
*!*	            IF lnpos > 0 
*!*	               lcupdversion=substr(lcUpdExe,lnpos+11,8)
*!*	               lcUpdExe = ""
*!*	            ENDIF
*!*	         ENDIF


         IF ALLTRIM(lcinstversion) <> ALLTRIM(lcupdversion)                 && aktuellere Programmversion vorhanden...
            IF FILE(lcupdpath+"MAGOG_UPD.EXE")
               =messagebox("Es wird eine neue Programmversion installiert."+chr(13)+"A new program version will be installed.",64,"Information")
               IF AT("\\",lcupdpath)=1          
                  lcexeccommand = lcupdpath+'MAGOG_UPD.EXE '+tcupdfile+';\'+lcupdpath
               ELSE
                  lcexeccommand = lcupdpath+'MAGOG_UPD.EXE '+tcupdfile+';'+lcupdpath
               ENDIF
               IF NOT EMPTY(tcGroup)   && Programmstart mit Zusatzparameter (alternativer Registry Schlssel!!!)
                  lcexeccommand = lcexeccommand+';'+tcGroup
               ENDIF
               ON SHUTDOWN
               RUN /N &lcexeccommand
               clear events
               QUIT
               QUIT
            ELSE
               =messagebox("Das MultiConverter-Update Programm ist nicht vorhanden!"+chr(13)+"Das Update konnte nicht installiert werden."+chr(13)+"The MultiConverter-Update program is missing!"+chr(13)+"The update was not installed"),16)
               llok=.F.
            ENDIF
         ENDIF
      ENDIF
   ENDIF
RETURN(llok)   && END CHECK_PRGUPDATE


FUNCTION ErrorHandler(nError,cMethod,nLine, cZeile)  && Globales Fehlerhandling -> Sollte nur im Notfall angesprungen werden
	LOCAL lcErrorMsg,lcCodeLineMsg, lcTable,lnFehlerfrage,lnAufrufstapel
	LOCAL ARRAY laAufrufstapel(1)
	*  goapp.screencapture.startcapture = .t.
	WAIT CLEAR
	lcCodeLineMsg=cZeile
	IF TYPE("lcCodeLineMsg")<>"C"
    	lcCodeLineMsg = "..."
	ENDIF
	*MB 24.07.2003 - Es gibt keine ZEILEN Auswertung mehr, weil wir nurnoch OHNE DEBUGINFO Programmieren
	*IF BETWEEN(nLine,1,10000) AND NOT lcCodeLineMsg="..."
	*	lcErrorMsg=lcErrorMsg+CHR(13)+"Zeile:         "+ALLTRIM(STR(nLine))
	*	IF NOT EMPTY(lcCodeLineMsg)
	*		lcErrorMsg=lcErrorMsg+CHR(13)+CHR(13)+lcCodeLineMsg
	*	ENDIF
	*ENDIF
	IF _vfp.startmode=0 &&Entwicklungsumgebug soll IMMER im DEBUG modus landen
  		ON ERROR
  		DEBUG
  		RETRY()
	ELSE
		*Dieser CODE luft in der ausgelieferten EXE ab
		*MB 21.07.2003 - Wir wollen nicht nur OK und Abbrechen... wir wollen BEENDEN,WIEDERHOLEN und ABBRECHEN
		=ASTACKINFO(laAufrufstapel)
		DO FORM forms\frmerror WITH nError,MESSAGE(),cMethod,IIF(TYPE("_SCREEN.ACTIVEFORM")="O" AND !EMPTY(SYS(1271,_screen.activeform)),JUSTSTEM(SYS(1271,_screen.activeform)),""),laAufrufstapel TO lnFehlerfrage
		DO CASE
		CASE lnFehlerfrage = 3 &&BEENDEN
			ON ERROR
			CANCEL
		CASE lnFehlerfrage = 4 &&WIEDERHOLEN
			RETRY()
		OTHERWISE
			RETURN(.F.)
		ENDCASE
	ENDIF
ENDFUNC

PROCEDURE noerror
*-- Null-Func zum abfang nicht kritischer Fehler...
RETURN

PROCEDURE VFPInit
  CLEAR
  SET EXCLUSIVE OFF
  SET CONSOLE ON
  SET DELETED OFF

  _SCREEN.WINDOWSTATE = 2
  _SCREEN.FontName    = "ARIAL"
  _SCREEN.ForeColor   = RGB(0,0,255)
  _SCREEN.FontBold    = .T.

  ? "   VFPCMD"
  ? ""
  _SCREEN.FontBold    = .F.
  ? "   Version 2.0a"
  ? "   OPTI-Soft GmbH, Oldenburg"
  ? ""
  ? ""
RETURN


PROCEDURE VFPClose
  CLEAR
  _SCREEN.WINDOWSTATE = 2
  ? ""
RETURN


PROCEDURE VFPDoCommand
LPARAMETERS cCommand
LOCAL lIni
   IF TYPE("cCommand") <> "C"
      cCommand = ""
   ENDIF
   IF not lini
      IF FILE(sys(2023)+"\exec.osh")
         ERASE sys(2023)+"\exec.osh"
      ENDIF
      StrToFile(cCommand,sys(2023)+"\exec.osh")
      IF FILE(sys(2023)+"\oldvalue.mem")
         restore from sys(2023)+"\oldvalue.mem" ADDITIVE
      ENDIF
      cCommand = FileToStr(sys(2023)+"\exec.osh")
   ELSE
      lIni = .F.
   ENDIF
   
   &cCommand
   
   IF FILE(sys(2023)+"\oldvalue.mem")
      ERASE sys(2023)+"\oldvalue.mem"
   ENDIF
   SAVE to sys(2023)+"\oldvalue.mem"
   
RETURN

PROCEDURE VFP_Update
LOCAL llok
   llOk = .t.
   RegRoot              = HKEY_LOCAL_MACHINE 
   RegGroup             = "Software\P30\MultiConverter"
   RegPrgN_ProgKey      = "ProgramPath"
   RegPrgN_ProgValue    = ""
   lcProgValue          = ""
   
   IF VARTYPE(oregistry)<>"O"
      oregistry=newobject("registry",".\fwk\libs\Registry.vcx")
   ENDIF
	IF oregistry.getregkey(RegPrgN_ProgKey,@lcProgValue,RegGroup,RegRoot)=0
		lcpath = ADDBS(lcProgValue)
		lcfile = "SPERRUNG"
		IF FILE(lcpath+lcfile)
			=MESSAGEBOX("Es wir gerade ein Update Ihrer Software vorgenommen, bitte probieren Sie es in 10 Minuten nochmals.",0+16,"Update")
			llOk = .f.
		ENDIF
		IF FILE(lcpath+lcfile+"_EN")
			=MESSAGEBOX("There is running a software update. Please try again in 10 minutes.",0+16,"Update")
			llOk = .f.
		ENDIF
	ELSE
	
	ENDIF
RETURN(llOk)