PARAMETERS tcStartupParam, tlDebugMode
DO MAIN_PROG WITH tcStartupParam, tlDebugMode && OLD STARTUP METHOD
&&DO MAIN_APP_STARTUP WITH tcStartupParam, tlDebugMode && NEW STARTUP METHOD

*!* Main_App_Startup
*!*
*!* This method will start the application.
*!* It allows to use the multi language support and shows a main form incl.
*!* a status bar.
*!* 
*!* Required Parameter(s):
*!*	tcStartupParam	=	this allows to set different startup modes for the application,
*!* 					which can be used to hide objects from the enduser,...
*!*						Possible values are: 
*!*							"-NE"........: enables the application with the foxpro 
*!*							               menu still active.
*!* 						"-DEVEL".....: enables all settings for the developer
*!*							               includes data manipulation features that
*!*							               are not allowed by the end-user.
*!*							"-SHOWHIDDEN": for features that are currently only 
*!*							               available to some users (e.g. beta 
*!*							               tester). The features may have sideeffects
*!*							               and are not yet intended to be used by 
*!*							               normal users.
*!*	
*!* Optional Parameter(s):     
*!* tlDebugMode		= Enable or disable DebugMode (default is off)
*!*
*!*	PROCEDURE main_app_startup
*!*	PARAMETERS tcStartupParam, tlDebugMode
*!*	PUBLIC goMainApp as Object 
*!*	PUBLIC gcScreenCaption, gcScreenIcon, gnScreenBackColor, gnScreenWindowState
*!*		ON ERROR
*!*		&& if the shutdown event is called call AppQuit()
*!*		ON SHUTDOWN AppQuit()

*!*		&& check parameters
*!*		IF VARTYPE(tcStartupParam) != "C" THEN
*!*			tcStartupParam = ""
*!*		ELSE
*!*			tcStartupParam = UPPER(tcStartupParam)
*!*		ENDIF
*!*		
*!*		IF VARTYPE(tlDebugMode) != "L" THEN
*!*			tlDebugMode = .F.
*!*		ENDIF

*!*		&& save default environment settings
*!*		gcScreenCaption     = _screen.Caption
*!*		gcScreenIcon        = _screen.Icon
*!*		gnScreenBackColor   = _screen.BackColor
*!*		gnScreenWindowState = _screen.WindowState
*!*		
*!*		
*!*		&& set new values
*!*		_screen.Caption   = 'VFP Data Converter v0.60 - 2006-01-06'
*!*		_screen.Icon      = 'graphics\icons\VFPDataConverter.ico'
*!*		_screen.BackColor = RGB(255,255,255) && weiss
*!*		_screen.WindowState = 2
*!*		
*!*		
*!*		&& ==========================
*!*		&&   Init the main gui form
*!*		&& ==========================
*!*		goMainApp = NEWOBJECT("frmappl",".\libs\mainappl.vcx")
*!*		IF TYPE("goMainApp")=="O" AND !ISNULL(goMainApp) THEN
*!*			READ EVENTS
*!*		ENDIF
*!*		
*!*		
*!*		&& we always start the application in NOEVENT mode
*!*		_screen.Caption     = gcScreenCaption
*!*		_screen.Icon        = gcScreenIcon
*!*		_screen.BackColor   = gnScreenBackColor
*!*		_screen.WindowState = gnScreenWindowState

*!*		SET SYSMENU TO DEFAULT
*!*		
*!*		CLEAR ALL
*!*		CLOSE DATABASES ALL
*!*		CLEAR 
*!*		IF _vfp.StartMode # 0
*!*			QUIT
*!*		ENDIF
*!*		
*!*	ENDPROC



*!* Main_Prog
*!*
*!* This is the old method to start the application. As long as the new 
*!* start method is not completed this one can be used.
*!* 
*!* Required Parameter(s):
*!*	tcStartupParam	=	this allows to set different startup modes for the application,
*!* 					which can be used to hide objects from the enduser,...
*!*						Possible values are: 
*!*							"-NE"........: enables the application with the foxpro 
*!*							               menu still active.
*!* 						"-DEVEL".....: enables all settings for the developer
*!*							               includes data manipulation features that
*!*							               are not allowed by the end-user.
*!*							"-SHOWHIDDEN": for features that are currently only 
*!*							               available to some users (e.g. beta 
*!*							               tester). The features may have sideeffects
*!*							               and are not yet intended to be used by 
*!*							               normal users.
*!*	
*!* Optional Parameter(s):     
*!* tlDebugMode		= Enable or disable DebugMode (default is off)
*!*
PROCEDURE main_prog
PARAMETERS tcStartupParam, tlDebugMode
PUBLIC gcScreenCaption, gcScreenIcon, gnScreenBackColor, gnScreenWindowState

	&& check parameters
	IF VARTYPE(tcStartupParam) != "C" THEN
		tcStartupParam = ""
	ELSE
		tcStartupParam = UPPER(tcStartupParam)
	ENDIF

	IF VARTYPE(tlDebugMode) != "L" THEN
		tlDebugMode = .F.
	ENDIF

	SET DELETED ON


	SET PROCEDURE TO .\progs\tools ADDITIVE
	SET PATH TO .;FORMS;LIBS;LIBS\WIZARDADDONS;LIBS\WIZARDADDONS\GRAPHICS;FWK\LIBS;PROGS;PROGS\APP;MENU;MENU\GPL;graphics;graphics\icons;DATA; ADDITIVE

	&& save default environment settings
	gcScreenCaption     = _screen.Caption
	gcScreenIcon        = _screen.Icon
	gnScreenBackColor   = _screen.BackColor
	gnScreenWindowState = _screen.WindowState

	&& if the shutdown event is called call AppQuit()
	ON SHUTDOWN AppQuit()

	&& set new values
	
	_screen.Hide	
	_screen.LockScreen = .T.
	_screen.Caption   = 'VFP Data Converter v0.61 (c) - 2006-03-28'
	_screen.Icon      = 'graphics\icons\VFPDataConverter.ico'
	_screen.BackColor = RGB(255,255,255) && weiss
	_screen.WindowState = 2

	&&SET CLASSLIB TO 
	IF AT("-DEVEL", tcStartupParam) > 0 THEN
		DO menu\mainmenu_devel.mpr
	ELSE
		DO mainmenu.mpr
	ENDIF

	_screen.Show	
	_screen.LockScreen = .F.

	&& Show authentication dialog
	IF NOT AuthCode( "INPUT" )
		AppQuit()		&& If not valid or time bomb time ran out, exit application.
	ENDIF


&&	_screen.Show
	





	&& if tlDebugMode = .T. activate debug...
	IF tlDebugMode THEN
		SET STEP ON
	ENDIF


	IF AT("-DEVEL", tcStartupParam) > 0 THEN
		DO FORM frm0001
	ENDIF
	****************
	IF AT("-NE", tcStartupParam) == 0 THEN
		READ EVENTS
	ENDIF
	****************

	_screen.Caption     = gcScreenCaption
	_screen.Icon        = gcScreenIcon
	_screen.BackColor   = gnScreenBackColor
	_screen.WindowState = gnScreenWindowState

	SET SYSMENU TO DEFAULT

	RELEASE ALL EXTENDED
ENDPROC


FUNCTION AppQuit
	CLEAR EVENTS
	ON SHUTDOWN
ENDFUNC
