DEFINE CLASS ICAL_CONTROL AS Custom
* -------------------------------------------------------------------------------- *
*	ICAL_CONTROL
*	=============================================
*	Desc (short):	This class allows to convert an ICAL calendar file into 
*					WebDAV XML (for Open-Xchange)
*	Autor.......:	Juergen Ulbts (J.U.)
*	Copyright...:	2005 - Juergen Ulbts
*	Version.....:	0.01 - 2005-08-03
*	VFP Version.:	VFP 7.0
*	Description.:	This class allows to convert an ICAL calendar file into
*					other formats like WebDAV XML and the special Open-Xchange
*					XML calendar files.
*					It's possible that I'll add to convert WebDAX XML/Open-Xchange
*					XML back into ICAL format later.
*
*	History.....:	Format: DATE/DATUM - DEVELOPER/ENTWICKLER (INITIALIEN) - CHANGES/AENDERUNG (multiline/mehrzeilig)
*						2005-08-03 - J.U. -	work started and canceled...found other solution...
*													
*	Methods.....:	init()
*                 	                                                               
* -------------------------------------------------------------------------------- *

****************
* SET BY INIT  *
****************
PROTECTED cCRLF						&& CRLF
PROTECTED cTAB						&& TAB


PROTECTED cICAL


*!* Init for this class 
*!*
*!* Required Parameter(s):
*!*	NONE
*!*
*!* Optional Parameter(s):     
*!*	NONE
*!*
PROTECTED PROCEDURE init
	DODEFAULT()
	this.cCRLF           = CHR(13)+CHR(10) 
	this.cTAB			= CHR(9)
RETURN
ENDPROC


ENDDEFINE && END OF CLASS DEFINITION
