
FUNCTION Number2Spread
LPARAMETERS tnColumn
LOCAL lcReturn, laArray, lnCounter, lnRest, lnColumn
	lcReturn = ""
	
	IF tnColumn > 0 AND VARTYPE(tnColumn) == "N" THEN
		lnRest = 0
		lnColumn = tnColumn
		DIMENSION laArray[26]
		FOR lnCounter = 1 TO 26 && fill Array with Characters from 'A'..'Z'
			STORE CHR(64+lnCounter) TO laArray[lnCounter] 
		ENDFOR
		DO WHILE lnColumn > 26
			lnRest = lnColumn % 26
			lnColumn = lnColumn / 26
			lcReturn = laArray[lnRest] + lcReturn
		ENDDO
		lcReturn = laArray[lnColumn] + lcReturn
	ENDIF
RETURN(lcReturn)
ENDFUNC


FUNCTION FindObjs
LPARAMETERS tothis, tcClass, taObjs
DIMENSION taObjs(1)
LOCAL lnLauf, loResult, lnIndex
	lnIndex = 0
	loResult = ""
	
	IF pemstatus(tothis, "Controls", 5) && does "Controls" exist...
		FOR lnLauf = 1 TO tothis.CONTROLCOUNT
			IF UPPER(tothis.CONTROLS(lnLauf).CLASS) == UPPER(tcClass) THEN
				lnIndex = lnIndex + 1
				DIMENSION taObjs(lnIndex)
				taObjs(lnIndex) = tothis.CONTROLS(lnLauf)
			ENDIF
		NEXT lnLauf
	ENDIF
	IF lnIndex > 0 THEN
		loResult = taObjs(1)
	ENDIF
RETURN(loResult)
ENDFUNC


FUNCTION cFindObjBy
LPARAMETERS tothis, tcProp, tcvalue, taObjs
DIMENSION taObjs(1)
LOCAL lnLauf, loResult, lnIndex,lcvar,lcvalue
	lnIndex = 0
	loResult = ""
	
	IF PEMSTATUS(tothis, "Controls", 5) THEN && does "Controls" exist...
		FOR lnLauf = 1 TO tothis.CONTROLCOUNT
			lcvar = "tothis.Controls(lnLauf)."+tcProp
			IF PEMSTATUS(tothis.CONTROLS(lnLauf), tcProp, 5) THEN && does the property exist...
				lcvalue = EVALUATE(lcvar)
				IF VARTYPE(lcvalue)="C"  && Prfung und Behandlung von Nummerischen Werten ergnzt - J.U. - 2000-07-27
					IF UPPER(lcvalue) == UPPER(tcvalue) THEN
						lnIndex = lnIndex + 1
						DIMENSION taObjs(lnIndex)
						taObjs(lnIndex) = tothis.CONTROLS(lnLauf)
					ENDIF
				ELSE
					IF lcvalue=VAL(tcvalue) THEN
						lnIndex = lnIndex + 1
						DIMENSION taObjs(lnIndex)
						taObjs(lnIndex) = tothis.CONTROLS(lnLauf)
					ENDIF
				ENDIF
			ENDIF
		NEXT lnLauf
	ENDIF
	IF lnIndex > 0 THEN
		loResult = taObjs(1)
	ENDIF
RETURN(loResult)
ENDFUNC



FUNCTION fieldnum
LPARAMETERS tcFeld, tcAlias
LOCAL lnLauf, lnResult
	lnResult = 0
	
	IF NOT EMPTY(tcAlias)
		SELECT(tcAlias)
	ENDIF

	IF NOT EMPTY(tcFeld)
		FOR lnLauf = 1 TO FCOUNT()
			IF UPPER(PADR(tcFeld, 10)) = UPPER(PADR(FIELD(lnLauf), 10))
				lnResult = lnLauf
			ENDIF
		NEXT lnLauf
	ENDIF
RETURN(lnResult)
ENDFUNC


PROCEDURE objbycontrol
LPARAMETERS toMainObj, tcControlSource
LOCAL llok, lnLauf, loRef, lnfldstate, lcAlias, loResult
LOCAL loObjHolder, loRef2, lcObjPath, lcObjPath2, lnLauf2, loReturn,lox
	IF VARTYPE(toMainObj) ="O" AND NOT EMPTY(tcControlSource)
		loObjHolder = toMainObj
		llok = .T.
		FOR lnLauf = 1 TO loObjHolder.CONTROLCOUNT
			loRef     = loObjHolder.CONTROLS(lnLauf)
			lcObjPath = SYS(1272,loRef)
			DO CASE
			CASE loRef.BASECLASS = "Page"
				FOR lnLauf2 = 1 TO loRef.PAGECOUNT
					loRef2     = loRef.PAGES[lnlauf2]
					loReturn = objbycontrol(loRef.PAGES[lnlauf2],tcControlSource)
					IF VARTYPE(loReturn) = "O"
						loResult = (loReturn)
					ENDIF
				NEXT lnLauf2
			CASE loRef.BASECLASS = "Container"
				lox = objbycontrol(loRef,tcControlSource)
				IF VARTYPE(loReturn) = "O"
					loResult = (loReturn)
				ENDIF
			OTHERWISE
				IF pemstatus(loRef,"ControlSource",5) AND NOT EMPTY(loRef.CONTROLSOURCE)
					IF ALLTRIM(UPPER(loRef.CONTROLSOURCE)) == ALLTRIM(UPPER(tcControlSource))
						loResult = loRef
					ENDIF
				ENDIF
			ENDCASE
		NEXT lnLauf
	ENDIF
IF VARTYPE(loResult) <> "O"
	loResult = ""
ENDIF
RETURN(loResult)
ENDPROC


FUNCTION csv2string
*--	 1.) Ermittelt die Anzahl von Parameteren (mit , getrennt) wenn nur der String uebergeben wird
*--	 2.) Gibt den einzelnen Parameter zurueck, wenn der Parameter tnitem mit uebergeben wird.
LPARAMETERS tcstring, tnitem, tcSeparator
	IF EMPTY(tcstring)
		RETURN 0
	ELSE
		IF EMPTY(tcSeparator)
			tcSeparator = ","
		ENDIF
		IF EMPTY(tnitem)  && return number of items
			RETURN OCCURS(tcSeparator, tcstring)+1
		ELSE
			RETURN LTRIM(GETWORDNUM(tcstring, tnitem, tcSeparator))
		ENDIF
	ENDIF
RETURN ""
ENDFUNC


*!*	EDI2String
*!*	Diese Routine verhaelt sich aehnlich wie cvs2string beruecksichtigt aber EDI Sonderfaelle 
*!*	wie "++" oder Rueckgabe von 0 wenn tcSeparator nicht im Suchstring vorkommt
*--	 1.) Ermittelt die Anzahl von Parameteren (mit , getrennt) wenn nur der String uebergeben wird
*--	 2.) Gibt den einzelnen Parameter zurueck, wenn der Parameter tnitem mit uebergeben wird.
FUNCTION edi2string 
LPARAMETERS tcstring, tnitem, tcSeparator
LOCAL laArray, lnArraySize
DIMENSION laArray(1) && Array which holds the EDI data elements

	IF EMPTY(tcstring)
		RETURN 0
	ELSE
		&& if tcSeparator includes none or more than one TAB and 
		&& the string is otherwise empty set tcSeparator to ","
		IF (OCCURS("	", tcSeparator) != 1 AND EMPTY(tcSeparator)) THEN
			tcSeparator = ","
		ENDIF
		
		IF EMPTY(tnitem)  && return number of items
			IF OCCURS(tcSeparator, tcstring) == 0 THEN  && J.U. - 2005-03-07
				RETURN 0 && J.U. - 2005-03-07
			ELSE && J.U. - 2005-03-07
				RETURN OCCURS(tcSeparator, tcstring)+1
			ENDIF && J.U. - 2005-03-07
		ELSE
			lnArraySize = ALINES(laArray, tcstring, .T., tcSeparator) && put data string into array and remove spaces (TRIM)!
			IF tnitem <= lnArraySize THEN
				RETURN laArray[tnitem]
			ELSE
				RETURN ""
			ENDIF
		ENDIF
	ENDIF
RETURN ""
ENDFUNC


PROCEDURE delim2string
LPARAMETERS tcdelim,tcstring, tnitem
	IF NOT EMPTY(tcstring) AND NOT EMPTY(tcdelim)
		IF EMPTY(tnitem) .or. tnitem = 0  && return number of items
			RETURN OCCURS(ALLTRIM(tcdelim),tcstring)+1
		ELSE
			RETURN GETWORDNUM(tcstring,tnitem,ALLTRIM(tcdelim))
		ENDIF
	ELSE
		RETURN 0
	ENDIF
ENDPROC


FUNCTION mask2nk
LPARAMETERS tcMask
LOCAL lnResult
	lnResult = 0
	IF NOT EMPTY(tcMask)
		tcMask = ALLTRIM(tcMask)
		IF AT(".",tcMask) > 0
			lnResult = LEN(tcMask) - AT(".",tcMask)
		ENDIF
	ENDIF
RETURN(lnResult)
ENDFUNC


*!* ===============================
*!*  BEGIN TIMEZONE FUNCTION BLOCK
*!* ===============================

*!*
*!* Converts the supplied date and time information to a unix timestamp 
*!* (seconds or milliseconds since 1. January 1970, 12pm (00:00 h)).
*!*
*!* Required Parameter(s):
*!* ======================
*!*   tcDate = Date in string format CCYY-MM-DD or DD.MM.CCYY
*!*   tcTime = Time in string format HH:MM:SS
*!*
*!* Optional Parameter(s):
*!* ======================
*!*   tlmsec     = If true it returns the date as miliseconds instead seconds
*!*   tlTimeZone = If true it compares the local timezone with GMT and adds or
*!*                subtracts seconds. The timestamp is then in GMT.
*!*                Default value is false!!!
*!*
*!* Returns:
*!* ========
*!*   If the conversion contained wrong input data it returns ""
*!*   otherwise the seconds/milliseconds (see optional parameter) 
*!*	  since 1970-01-01 as string.
*!*
FUNCTION unixTimeStamp
LPARAMETERS tcDate, tcTime, tlmsec, tlTimeZone
LOCAL tUnixStartDate, tCurrent, tDifference
LOCAL lnYear as Integer, lnMonth as Integer, lnDay as Integer
LOCAL lnHour as Integer, lnMinute as Integer, lnSecond as Integer
LOCAL lReturnSeconds as Long, llok as Boolean

	lReturnSeconds = 0
	llok = .T.
	
	IF VARTYPE(tlmsec) != "L" THEN
		tlmsec = .F.
	ENDIF
	
	IF VARTYPE(tlTimeZone) != "L" THEN
		tlTimeZone = .F.
	ENDIF
	
	
	&& check tcDate and work with it...otherwise set llok to .F.
	IF VARTYPE(tcDate) == "C" THEN
		tcDate = ALLTRIM(tcDate)
		
		DO CASE
			CASE ((OCCURS('.', tcDate) == 2) AND (LEN(tcDate) == 10))
				TRY 
					IF (IsNumber(SUBSTR(tcDate, 1, 2))) THEN
						lnDay   = VAL(SUBSTR(tcDate, 1, 2))
					ELSE
						llok = .F.
					ENDIF

					IF (IsNumber(SUBSTR(tcDate, 4, 2))) THEN
						lnMonth = VAL(SUBSTR(tcDate, 4, 2))
					ELSE
						llok = .F.
					ENDIF
					
					IF (IsNumber(SUBSTR(tcDate, 7, 4))) THEN
						lnYear  = VAL(SUBSTR(tcDate, 7, 4))
					ELSE
						llok = .F.
					ENDIF
				CATCH
					llok = .F.
				ENDTRY
				
			CASE ((OCCURS('-', tcDate) == 2) AND (LEN(tcDate) == 10))
				TRY 

					IF (IsNumber(SUBSTR(tcDate, 9, 2))) THEN
						lnDay   = VAL(SUBSTR(tcDate, 9, 2))
					ELSE
						llok = .F.
					ENDIF

					IF (IsNumber(SUBSTR(tcDate, 6, 2))) THEN
						lnMonth = VAL(SUBSTR(tcDate, 6, 2))
					ELSE
						llok = .F.
					ENDIF

					IF (IsNumber(SUBSTR(tcDate, 1, 4))) THEN
						lnYear  = VAL(SUBSTR(tcDate, 1, 4))
					ELSE
						llok = .F.
					ENDIF
					
				CATCH
					llok = .F.
				ENDTRY
				
			OTHERWISE
				llok = .F.
		ENDCASE
		
		&& Extra check day, month and year
		&& lazy check (2005-02-31 would be valid) but better than nothing
		IF llok THEN
			IF !(lnDay > 0 AND lnDay < 32) THEN
				llok = .F.
			ENDIF

			IF !(lnMonth > 0 AND lnMonth < 13) THEN
				llok = .F.
			ENDIF
			
			IF (lnYear < 1970) THEN
				llok = .F.
			ENDIF
		ENDIF
	ELSE
		llok = .F.
	ENDIF
	
	&& check tcTime and work with it...otherwise set llok to .F.
	IF VARTYPE(tcTime) == "C" THEN
		tcTime = ALLTRIM(tcTime)
		
		IF ((OCCURS(':', tcTime) == 2) AND (LEN(tcTime) == 8)) THEN
			TRY
				&& =======
				&&  Hours
				&& =======
				IF (IsNumber(SUBSTR(tcTime, 1, 2))) THEN
					lnHour   = VAL(SUBSTR(tcTime, 1, 2))
				ELSE
					llok = .F.
				ENDIF
				
				IF !(lnHour >=0 AND lnHour < 24) THEN
					llok = .F.
				ENDIF
				
				&& =======
				&& Minutes
				&& =======
				IF (IsNumber(SUBSTR(tcTime, 4, 2))) THEN
					lnMinute = VAL(SUBSTR(tcTime, 4, 2))
				ELSE
					llok = .F.
				ENDIF
					
				IF !(lnMinute >=0 AND lnMinute < 60) THEN
					llok = .F.
				ENDIF
				
				&& =======
				&& Seconds
				&& =======
				IF (IsNumber(SUBSTR(tcTime, 7, 2))) THEN
					lnSecond = VAL(SUBSTR(tcTime, 7, 2))
				ELSE
					llok = .F.
				ENDIF					

				IF !(lnSecond >=0 AND lnSecond < 60) THEN
					llok = .F.
				ENDIF
			CATCH
				llok = .F.
			ENDTRY 
		ELSE
			llok = .F.
		ENDIF
	ELSE
		llok = .F.
	ENDIF

	&& if everything is ok finally set dates and calculate the seconds...
	IF llok THEN
		tUnixStartDate = DATETIME(1970, 1, 1, 0, 0, 0) && 1st January 1970 00:00 UTC
		tCurrent = DATETIME(lnYear, lnMonth, lnDay, lnHour, lnMinute, lnSecond)
		lReturnSeconds = tCurrent - tUnixStartDate
		
		IF tlTimeZone THEN
			lReturnSeconds = lReturnSeconds + (getBiasMinutesToGMT(tCurrent) * 60)
		ENDIF
		
		IF tlmsec THEN
			lReturnSeconds = lReturnSeconds * 1000
		ENDIF
	ENDIF
	
RETURN IIF(lReturnSeconds>0, TRANSFORM(lReturnSeconds), "")
ENDFUNC


*!* Tests if string only contains character from 0..9 or also other
*!* characters.
*!*
*!* Parameters:
*!* ===========
*!*   tcString = String to test for numbers
*!*
*!* Returns:
*!* ========
*!*   Returns 'true' if all characters in the string are between 0..9
*!*   otherwise 'false'.
*!*
FUNCTION isNumber
LPARAMETERS tcString
LOCAL lnLength as Integer, lnPosition as Integer
LOCAL llReturnCode as Boolean
	llReturnCode = .T.
	
	IF VARTYPE(tcString) == "C" THEN
		lnLength = LEN(tcString)
		FOR lnPosition = 1 TO lnLength
			IF (OCCURS( SUBSTR(tcString, lnPosition, 1), '0123456789' ) == 0) THEN
				llReturnCode = .F.
				EXIT
			ENDIF
		ENDFOR
	ELSE
		llReturnCode = .F.
	ENDIF
	
RETURN llReturnCode
ENDFUNC


*!* getSystemTime
*!* This function returns the datetime value with the system time (UTC).
*!*
*!* Parameters:
*!* ===========
*!*   NONE
*!*
*!* Returns:
*!* ========
*!*   Returns a number and 0 as default.
*!*
FUNCTION getSystemTime
LOCAL lcWin32SystemTime
LOCAL lnYear, lnMonth, lnDay, lnHour, lnMinute, lnSecond
LOCAL ltSystemDateTime

	#DEFINE SYSTEMTIME_SIZE  16
	*!* typedef struct _SYSTEMTIME {  
	*!*     WORD wYear;  
	*!*     WORD wMonth;  
	*!*     WORD wDayOfWeek;  
	*!*     WORD wDay;  
	*!*     WORD wHour;  
	*!*     WORD wMinute;  
	*!*     WORD wSecond;  
	*!*     WORD wMilliseconds;  
	*!* } SYSTEMTIME, *PSYSTEMTIME; -> 16 bytes 	
	
	&& Init Variable
	lcWin32SystemTime = REPLICATE(Chr(0), SYSTEMTIME_SIZE)  && SYSTEMTIME structure
	
	&& Register Win32 time functions
	registerWin32TimeFunctions()
	&& GetSystemTime - Win32 call
	=GetSystemTime (@lcWin32SystemTime)
	
	lnYear   = buf2word (SUBSTR(lcWin32SystemTime,  1, 2))
	lnMonth  = buf2word (SUBSTR(lcWin32SystemTime,  3, 2))  
	lnDay    = buf2word (SUBSTR(lcWin32SystemTime,  7, 2))  
	lnHour   = buf2word (SUBSTR(lcWin32SystemTime,  9, 2))  
	lnMinute = buf2word (SUBSTR(lcWin32SystemTime, 11, 2))  
	lnSecond = buf2word (SUBSTR(lcWin32SystemTime, 13, 2))
	
	ltSystemDateTime = DATETIME(lnYear, lnMonth, lnDay, lnHour, lnMinute, lnSecond)
RETURN ltSytemDateTime
ENDFUNC


*!* getBiasMinutesToGMT - NO REAL ERROR HANDLING - BEWARE!!!
*!* This function returns the number of minutes that have to be added to
*!* the local time to get the GMT time. 
*!* It also checks daylight and normal time (Summer-/Wintertime)
*!* See Return value description for more details.
*!*
*!* Parameters:
*!* ===========
*!*   ttDateTime = DateTime object
*!*
*!* Returns:
*!* ========
*!*   Returns a number and 0 as default.
*!*   If the timezone is not GMT it returns the minutes to add to the current 
*!*   local time to get the GMT time.
*!*   If you live in a GMT+1 timezone (Amsterdam, Berlin, Bern, Rome, Stockholm, Vienna,...)
*!*   which is 1 hour (60 minutes) ahead you need to subtract one hour.
*!*   For a local GMT+1 timezone this function returns -60 (minutes)!
*!*
FUNCTION getBiasMinutesToGMT
LPARAMETERS ttDateTime
LOCAL lnBiasMinutesToGMT
LOCAL lcWin32TimeZone, llok as Boolean
	llok = .T.
	
	IF NOT VARTYPE(ttDateTime) == "T" THEN
		llok = .F.
	ENDIF

	#DEFINE TIME_ZONE_SIZE  172
	*!* typedef struct _TIME_ZONE_INFORMATION {
	*!*     LONG       Bias;                  0        4
	*!*     WCHAR      StandardName[ 32 ];    4       64
	*!*     SYSTEMTIME StandardDate;         68       16
	*!*     LONG       StandardBias;         84        4
	*!*     WCHAR      DaylightName[ 32 ];   88       64
	*!*     SYSTEMTIME DaylightDate;        152       16
	*!*     LONG       DaylightBias;        168        4
	*!* } TIME_ZONE_INFORMATION, *PTIME_ZONE_INFORMATION; total 172 bytes
	*!*
	
	&& Init variable
	lcWin32TimeZone = Replicate(Chr(0), TIME_ZONE_SIZE)
		
	&& Register Win32 time functions
	registerWin32TimeFunctions()
	
	&& GetTimeZoneInformation - Win32 call
	=GetTimeZoneInformation(@lcWin32TimeZone)
	
	lnBiasMinutesToGMT = 0
	IF llok AND NOT EMPTY(lcWin32TimeZone)
		&& calculate basic difference in minutes between local timezone and GMT
		lnBiasMinutesToGMT = buf2dword(SUBSTR(lcWin32TimeZone, 1, 4))
		
		&& ====================================================================
		&& CREATE BASIC DATE where the correct Daylight STARTDATE can be found!
		&& ====================================================================
		&& Get Year from DATETIME of the parameter, the month that STARTS daylight date from the 
		&& previously called Win32 function and set the day to the first of that month.
		ldDaylightStartYearMonth = DATE( YEAR(TTOD(ttDateTime)), buf2word(SUBSTR(lcWin32TimeZone, 155, 2)), 01) && "01.MM.YYYY"
		
		&& Get 1st, 2nd, 3rd, 4th or last (5) Sunday of the month and return the complete date
		ldDaylightStartYearMonth = getDateWithSundayX( ldDaylightStartYearMonth, buf2word(SUBSTR(lcWin32TimeZone, 159, 2)) ) && Date, Value from 1..5
		
		
		&& ==================================================================
		&& CREATE BASIC DATE where the correct Daylight ENDDATE can be found!
		&& ==================================================================
		&& Get Year from DATETIME of the parameter, the month that ENDS daylight date from the 
		&& previously called Win32 function and set the day to the first of that month.	
		ldDaylightEndYearMonth   = DATE( YEAR(TTOD(ttDateTime)), buf2word(SUBSTR(lcWin32TimeZone, 071, 2)), 01) && "01.MM.YYYY"

		&& Get 1st, 2nd, 3rd, 4th or last (5) Sunday of the month and return the complete date
		ldDaylightEndYearMonth = getDateWithSundayX( ldDaylightEndYearMonth, buf2word(SUBSTR(lcWin32TimeZone, 075, 2)) ) && Date, Value from 1..5
		
		&& ===========================================================================
		&& Create new DATETIME values to compare with the DATETIME from the parameter!
		&& ===========================================================================
		ltDaylightStart = DATETIME( YEAR(ldDaylightStartYearMonth), MONTH(ldDaylightStartYearMonth), DAY(ldDaylightStartYearMonth), buf2word(SUBSTR(lcWin32TimeZone,161,2)), 00, 00 )
		ltDaylightEnd   = DATETIME( YEAR(ldDaylightEndYearMonth),   MONTH(ldDaylightEndYearMonth),   DAY(ldDaylightEndYearMonth),   buf2word(SUBSTR(lcWin32TimeZone,77,2)),  00, 00 )
		
		&& now check the date and time to calculate the daylight difference (Summer-/Winter-Time)
		IF ttDateTime >= ltDaylightStart AND ttDateTime < ltDaylightEnd THEN
			lnBiasMinutesToGMT = lnBiasMinutesToGMT + buf2dword(SUBSTR(lcWin32TimeZone, 169, 4))
		ENDIF
	ENDIF
RETURN lnBiasMinutesToGMT
ENDFUNC


*!* getDateWithSundayX
*!* This function returns the number of minutes that have to be added to
*!* the local time to get the GMT time. 
*!* It also checks daylight and normal time (Summer-/Wintertime)
*!* See Return value description for more details.
*!*
*!* Parameters:
*!* ===========
*!*   tdDate          = Date object
*!*   tnSundayOfMonth = 1st (default), 2nd, 3rd, 4th or 5 (last) sunday
*!*                     If tnSundayOfMonth is not 1-5 it sets 
*!*                     tnSundayOfMonth to 1 (default).
*!*
*!* Returns:
*!* ========
*!*   Returns date (a sunday) for the requested date.
*!*
FUNCTION getDateWithSundayX
LPARAMETERS tdDate, tnSundayOfMonth
LOCAL lnSundayCounter as Integer, lnCounter as Integer, ldReturnDate as Date
	lnSundayCounter = 0
	
	&& Check date
	IF VARTYPE(tdDate) != "D" THEN
		tdDate = DATE()
	ENDIF
	
	&& Check which sunday should be returned or set default value
	IF VARTYPE(tnSundayOfMonth) == "N" THEN
		IF (tnSundayOfMonth < 1 OR tnSundayOfMonth > 5) THEN
			tnSundayOfMonth = 1
		ENDIF
	ELSE
		tnSundayOfMonth = 1
	ENDIF
	
	DO CASE
		CASE tnSundayOfMonth >=1 AND tnSundayOfMonth <= 4 && search 1st, 2nd, 3rd or 4th Sunday of the month
			FOR lnCounter = 0 TO DAY( GOMONTH(tdDate, 1)-1 ) - 1 && FROM 1st of month to last - go to 1st of next month and one day back (==last day of month from tdDate)
				IF CDOW(tdDate+lnCounter) == 1 THEN && 1 == Sunday
					lnSundayCounter = lnSundayCounter + 1
					IF lnSundayCounter == tnSundayOfMonth THEN
						ldReturnDate = tdDate + lnCounter
						EXIT
					ENDIF
				ENDIF
			ENDFOR
		CASE tnSundayOfMonth == 5 && search last Sunday of the month
			FOR lnCounter = DAY( GOMONTH(tdDate, 1)-1 ) - 1 TO 0 STEP -1 && FROM last day of month the 1st
				IF DOW(tdDate+lnCounter) == 1 THEN && 1 == Sunday
					ldReturnDate = tdDate + lnCounter
					EXIT
				ENDIF
			ENDFOR
	ENDCASE
RETURN ldReturnDate
ENDFUNC


*!* buf2dword - NO ERROR HANDLING - BEWARE!!!
*!* The function transforms the buffer string to a dword
*!*
*!* Parameters:
*!* ===========
*!*   tcBuffer = String to be processed
*!*
*!* Returns:
*!* ========
*!*   Returns dword (number)
*!*
FUNCTION buf2dword
LPARAMETERS tcBuffer
RETURN Asc(SUBSTR(tcBuffer, 1,1)) + ;
		BitLShift(Asc(SUBSTR(tcBuffer, 2,1)),  8) +;
		BitLShift(Asc(SUBSTR(tcBuffer, 3,1)), 16) +;
		BitLShift(Asc(SUBSTR(tcBuffer, 4,1)), 24)
ENDFUNC


*!* buf2word - NO ERROR HANDLING - BEWARE!!!
*!* The function transforms the buffer string to a word
*!*
*!* Parameters:
*!* ===========
*!*   tcBuffer = String to be processed
*!*
*!* Returns:
*!* ========
*!*   Returns word (number)
*!*
FUNCTION buf2word
LPARAMETERS tcBuffer
RETURN Asc(SUBSTR(tcBuffer, 1, 1)) + ;
		Asc(SUBSTR(tcBuffer, 2, 1)) * 256
ENDFUNC 


*!* registerWin32TimeFunctions
*!* Defines the Win32 Time/TimeZone functions from kernel32 to be
*!* able to call them from Visual FoxPro as normal functions.
*!*
*!* Parameters:
*!* ===========
*!*   NONE
*!*
PROCEDURE registerWin32TimeFunctions
    DECLARE INTEGER GetTimeZoneInformation IN kernel32;
        STRING @lpTimeZoneInformation

    DECLARE INTEGER SetTimeZoneInformation IN kernel32;
        STRING lpTimeZoneInformation

	DECLARE GetSystemTime IN kernel32;
		STRING @lpSystemTime && UTC/GMT TIME
		
	DECLARE GetLocalTime IN kernel32;
		STRING @lpSystemTime && == FOXPRO DATETIME(..)
ENDPROC



*!* displayLangInfo
*!* Displays language information returned from different Kernel32
*!* functions.
*!*
*!* Parameters:
*!* ===========
*!*   NONE
*!*
FUNCTION displayLangInfo
	&& Register Win32 language functions
	registerWin32LanguageFunctions()
	
	&& Call different language functions from kernel32
	? "System Default LangID....: ", GetSystemDefaultLangID()
	? "User Default LangID......: ", GetUserDefaultLangID()
	? "System Default LCID......: ", GetSystemDefaultLCID()
	? "User Default LCID........: ", GetUserDefaultLCID()
	? "Current Thread Locale....: ", GetThreadLocale()
	? "OEM code-page identifier.: ", GetOEMCP()
	? "ANSI code-page identifier: ", GetACP()
	? "Current code page (should be the same as GetOEMCP): ", GetKBCodePage()
ENDFUNC

*!* registerWin32LanguageFunctions
*!* Defines the Win32 language functions from kernel32 to be
*!* able to call them from Visual FoxPro as normal functions.
*!*
*!* Parameters:
*!* ===========
*!*   NONE
*!*
PROCEDURE registerWin32LanguageFunctions
	DECLARE SHORT GetSystemDefaultLangID IN kernel32
	DECLARE SHORT GetUserDefaultLangID   IN kernel32
	DECLARE SHORT GetSystemDefaultLCID   IN kernel32
	DECLARE SHORT GetUserDefaultLCID     IN kernel32
	DECLARE SHORT GetThreadLocale        IN kernel32

	DECLARE INTEGER GetOEMCP IN kernel32
	DECLARE INTEGER GetACP IN kernel32
	DECLARE INTEGER GetKBCodePage IN user32
ENDPROC

FUNCTION WordToInt(tcWordString, tlSigned)
LOCAL lcHexString as String, lnResult as Integer, lnChar as Integer
  lcHexString = '0x'

  FOR lnChar = LEN(tcWordString) TO 1 STEP -1
    lcHexString = lcHexString + PADL(RIGHT(TRANSFORM(ASC(SUBSTR(tcWordString, lnChar, 1)), '@0'), 2), 2, '0')
  ENDFOR
 
 
  lnResult = EVALUATE(lcHexString)
  IF tlSigned and lnResult > 0x80000000
    lnResult = lnResult - 1 - 0xFFFFFFFF
  ENDIF

RETURN lnResult
ENDFUNC


FUNCTION time2min
LPARAMETERS tcTime
LOCAL lnMinutes
	lnMinutes = 0
	IF LEN(tcTime)>4 AND csv2string(tcTime,0,":")=2
		lnMinutes=VAL(csv2string(tcTime,1,":"))*60+VAL(csv2string(tcTime,2,":"))
	ENDIF
RETURN(lnMinutes)
ENDFUNC


FUNCTION min2time
LPARAMETERS tnMinutes
LOCAL lcTime
	lcTime="00:00:00"
	IF tnMinutes>0
		lcTime=TRANSFORM(INT(tnMinutes/60),"@L 99")+":"
		tnMinutes=tnMinutes-(INT(tnMinutes/60)*60)
		IF tnMinutes>0
			lcTime=lcTime+TRANSFORM(tnMinutes,"@L 99")+":00"
		ELSE
			lcTime=lcTime+"00:00"
		ENDIF
	ENDIF
RETURN(lcTime)
ENDFUNC


FUNCTION time2sec
LPARAMETERS tcTime
LOCAL lnSeconds
	lnSeconds = 0
	IF LEN(tcTime) == 5 AND csv2string(tcTime,0,":") == 2 THEN
		lnSeconds=VAL(csv2string(tcTime,1,":"))*3600+VAL(csv2string(tcTime,2,":")*60)
	ELSE
		IF LEN(tcTime) == 8 AND csv2string(tcTime,0,":") == 3 THEN
			lnSeconds=VAL(csv2string(tcTime,1,":"))*3600+VAL(csv2string(tcTime,2,":")*60)+VAL(csv2string(tcTime,3,":"))
		ENDIF
	ENDIF
RETURN(lnSeconds)
ENDFUNC


FUNCTION sec2time
LPARAMETERS tnSeconds
LOCAL lcTime
lcTime="00:00:00"
	IF tnSeconds>0
		lcTime=TRANSFORM(INT(tnSeconds/3600),"@L 99")+":"   && Stunden
		tnSeconds=tnSeconds-INT(tnSeconds/3600)
		IF tnSeconds>0
			lcTime=lcTime+TRANSFORM(tnSeconds-(INT(tnSeconds/60)),"@L 99")+":"  && Minuten
			tnSeconds=tnSeconds-INT(tnSeconds/60)
			IF tnSeconds>0
				lcTime=lcTime+TRANSFORM(tnSeconds,"@L 99")  && Sekunden
			ELSE
				lcTime=lcTime+"00"
			ENDIF
		ELSE
			lcTime=lcTime+"00:00"
		ENDIF
	ENDIF
RETURN(lcTime)
ENDFUNC


*!* The function transforms the submitted parameter to a XML string.
*!* Characters that cause problems in an XML value string will be replaced 
*!* by the correct named entity.
*!* This function returns the changed string or an empty string if the 
*!* submitted string was empty.
*!*
*!* Parameters:
*!* ===========
*!*   tcString = String to be processed
*!*
*!* Returns:
*!* ========
*!*   Returns converted string
*!*
FUNCTION ANSI2XML
LPARAMETERS tcString
LOCAL lcString
	lcString = ""
	IF VARTYPE(tcString) == "C" AND NOT EMPTY(tcString) THEN
		lcString = tcString
		lcString = STRTRAN(lcString, "&", "&amp;")
		lcString = STRTRAN(lcString, "<", "&lt;")
		lcString = STRTRAN(lcString, ">", "&gt;")
		lcString = STRTRAN(lcString, '"', "&quot;")
		lcString = STRTRAN(lcString, "'", "&apos;")
	ENDIF
RETURN lcString
ENDFUNC


*!* The function transforms the submitted XML value string parameter 
*!* to a ANSI string.
*!* Characters that exist as named entity are replaced by their ANSI
*!* representation.
*!* This function returns the changed string or an empty string if the 
*!* submitted string was empty.
*!*
*!* Parameters:
*!* ===========
*!*   tcString = String to be processed
*!*
*!* Returns:
*!* ========
*!*   Returns converted string
*!*
FUNCTION XML2ANSI
LPARAMETERS tcString
LOCAL lcString
	lcString = ""
	IF VARTYPE(tcString) == "C" AND NOT EMPTY(tcString) THEN
		lcString = tcString
		lcString = STRTRAN(lcString, "&amp;",  "&")
		lcString = STRTRAN(lcString, "&lt;",   "<")
		lcString = STRTRAN(lcString, "&gt;",   ">")
		lcString = STRTRAN(lcString, "&quot;", '"')
		lcString = STRTRAN(lcString, "&apos;", "'")
	ENDIF
RETURN lcString
ENDFUNC


*!* The function transforms the submitted HTML string to a HTML 
*!* string with ANSI characters.
*!* Characters that exist as named entity are replaced by their ANSI
*!* representation.
*!* This function returns the changed string or an empty string if the 
*!* submitted string was empty.
*!*
*!* Parameters:
*!* ===========
*!*   tcString = String to be processed
*!*
*!* Returns:
*!* ========
*!*   Returns converted string
*!*
FUNCTION HTML2ANSI
LPARAMETERS tcString
LOCAL lcString
	lcString = ""
	IF VARTYPE(tcString) == "C" AND NOT EMPTY(tcString) THEN
		lcString = tcString
		lcString = STRTRAN(lcString,"&Uuml;","")
		lcString = STRTRAN(lcString,"&uuml;","")
		lcString = STRTRAN(lcString,"&Auml;","")
		lcString = STRTRAN(lcString,"&auml;","")
		lcString = STRTRAN(lcString,"&Ouml;","")
		lcString = STRTRAN(lcString,"&ouml;","")
		lcString = STRTRAN(lcString,"&szlig;","")
		lcString = STRTRAN(lcString,"&sup2;","")
		lcString = STRTRAN(lcString,"&sup3;","")
	ENDIF
RETURN(lcString)
ENDFUNC


*!* The function transforms the submitted string to a string with 
*!* ANSI characters transformed to their named entity.
*!* Characters that exist as named entity are replaced by their ANSI
*!* representation.
*!* This function returns the changed string or an empty string if the 
*!* submitted string was empty.
*!*
*!* Parameters:
*!* ===========
*!*   tcString = String to be processed
*!*
*!* Returns:
*!* ========
*!*   Returns converted string
*!*
FUNCTION ANSI2HTML
LPARAMETERS tcstring
LOCAL lcString
	lcString = ""
	IF VARTYPE(tcString) == "C" AND EMPTY(tcString) THEN
		lcString = tcString
		lcString = STRTRAN(lcString,"","&Uuml;")
		lcString = STRTRAN(lcString,"","&uuml;")
		lcString = STRTRAN(lcString,"","&Auml;")
		lcString = STRTRAN(lcString,"","&auml;")
		lcString = STRTRAN(lcString,"","&Ouml;")
		lcString = STRTRAN(lcString,"","&ouml;")
		lcString = STRTRAN(lcString,"","&szlig;")
		lcString = STRTRAN(lcString,"","&sup2;")
		lcString = STRTRAN(lcString,"","&sup3;")
	ENDIF
RETURN(lcString)
ENDFUNC


*!* The function transforms the submitted ASCII (CP850/437) string into
*!* string with using ANSI characters.
*!* This function returns the changed string or an empty string if the 
*!* submitted string was empty.
*!*
*!* Parameters:
*!* ===========
*!*   tcString = String to be processed
*!*
*!* Returns:
*!* ========
*!*   Returns converted string
*!*
FUNCTION ASCII2ANSI
LPARAMETERS tcstring
LOCAL lcString
	lcString = ""
	IF VARTYPE(tcString) == "C" AND EMPTY(tcString) THEN
		lcString = tcString
		lcString = STRTRAN(lcString,"","")
		lcString = STRTRAN(lcString,"","")
		lcString = STRTRAN(lcString,"","")
		lcString = STRTRAN(lcString,"","")
		lcString = STRTRAN(lcString,"","")
		lcString = STRTRAN(lcString,"","")
		lcString = STRTRAN(lcString,"","")
		lcString = STRTRAN(lcString,"","")
	ENDIF
RETURN(lcString)
ENDFUNC


*!* The function transforms the submitted ANSI string into
*!* string with using ASCII characters (CP850/437).
*!* This function returns the changed string or an empty string if the 
*!* submitted string was empty.
*!*
*!* Parameters:
*!* ===========
*!*   tcString = String to be processed
*!*
*!* Returns:
*!* ========
*!*   Returns converted string
*!*
FUNCTION ANSI2ASCII
LPARAMETERS tcstring
LOCAL lcString
	lcString = ""
	IF VARTYPE(tcString) == "C" AND EMPTY(tcString) THEN
		lcString = tcString
		lcString = STRTRAN(lcString,"","")
		lcString = STRTRAN(lcString,"","")
		lcString = STRTRAN(lcString,"","")
		lcString = STRTRAN(lcString,"","")
		lcString = STRTRAN(lcString,"","")
		lcString = STRTRAN(lcString,"","")
		lcString = STRTRAN(lcString,"","")
		lcString = STRTRAN(lcString,"","")
	ENDIF
RETURN(lcString)
ENDFUNC


FUNCTION date2kw
LPARAMETERS lddatum
RETURN(WEEK(lddatum,0,2))
ENDFUNC


FUNCTION kette2csv
LPARAMETERS tcString
LOCAL lnvals, lnLauf, lcResult,lcfeld,lnvon,lnbis,lnLauf2
	lcResult = ""
	IF NOT EMPTY(tcString)
		lcString = tcString
		** Nur das in den Klammern gilt!
		IF delim2string("(",lcString) > 0
			lcString =  delim2string("(",lcString, 2)
			lcString =  delim2string(")",lcString, 1)
		ENDIF
	
		** Felder anhand ";" trennen
		lnvals = delim2string(";",lcString)
		IF lnvals > 0
			FOR lnLauf = 1 TO lnvals
				lcfeld = delim2string(";", lcString, lnLauf)
				IF delim2string(":", lcfeld) = 1
					lcResult = lcResult + lcfeld + ","
				ELSE
					lnvon = VAL(delim2string(":", lcfeld, 1))
					lnbis = VAL(delim2string(":", lcfeld, 2))
					FOR lnLauf2 = lnvon TO lnbis
						lcResult = lcResult + ALLTRIM(STR(lnLauf2,10,0))+","
					NEXT lnLauf2
				ENDIF
			NEXT lnLauf
			
			lcResult = ALLTRIM(lcResult)
			IF NOT EMPTY(lcResult)
				lcResult = SUBSTR(lcResult, 1, LEN(lcResult)-1)
			ENDIF
		ENDIF
	ENDIF
RETURN(lcResult)
ENDFUNC


PROCEDURE dblookup
LPARAMETERS tcdbf, tcgrenzen, tccalc
LOCAL lresult, lcgrenzen, lccalc, lnOld_Sel, lcAlias
lnOld_Sel = SELECT()

	lresult = .F.
	IF VARTYPE(tcdbf) = "C"
		lcAlias = "_lockup_"+ALLTRIM(tcdbf)
		IF NOT USED(lcAlias)
			USE (tcdbf) ALIAS (lcAlias) IN 0 AGAIN
		ENDIF
		SELECT(lcAlias)
		IF VARTYPE(tcgrenzen) <> "C"
			lcgrenzen = " .t. "
		ELSE
			lcgrenzen = tcgrenzen
		ENDIF
		IF VARTYPE(tccalc) <> "C" && or UPPER(alltrim(tccalc)) = "GET"
			LOCATE FOR &lcgrenzen
			lresult = FOUND()
		ELSE
			lccalc = tccalc
			CALCULATE &lccalc FOR &lcgrenzen TO lresult
		ENDIF
	ENDIF
SELECT(lnOld_Sel)
RETURN(lresult)
ENDPROC


PROCEDURE dbinhalt
LPARAMETERS tcdbf, tcgrenzen, tcfeld
LOCAL lresult, lcgrenzen, lccalc, lnOld_Sel,lcAlias
lnOld_Sel = SELECT()

	lresult = .F.
	IF VARTYPE(tcdbf) = "C"
		lcAlias = "_lockup_inhalt_"+ALLTRIM(tcdbf)
		IF NOT USED(lcAlias)
			USE (tcdbf) ALIAS (lcAlias) IN 0 AGAIN
		ENDIF
		SELECT(lcAlias)
		IF VARTYPE(tcgrenzen) <> "C"
			lcgrenzen = " .t. "
		ELSE
			lcgrenzen = tcgrenzen
		ENDIF
		IF VARTYPE(tcfeld) <> "C" && or UPPER(alltrim(tccalc)) = "GET"
			LOCATE  FOR &lcgrenzen
			lresult = FOUND()
		ELSE
			lccalc = tcfeld
			LOCATE  FOR &lcgrenzen
			IF NOT FOUND()
				lresult = .F.
			ELSE
				lresult = &tcfeld
			ENDIF
		ENDIF
	ENDIF
	
SELECT(lnOld_Sel)
RETURN(lresult)
ENDPROC


PROCEDURE dbsatz
LPARAMETERS tcdbf, tcgrenzen
LOCAL lresult, lcgrenzen, lccalc, lnOld_Sel, loSatz, lcAlias
lnOld_Sel = SELECT()

	loSatz = .F.
	IF VARTYPE(tcdbf) = "C"
		lcAlias = "_lockup_satz_"+ALLTRIM(tcdbf)
		IF NOT USED(lcAlias)
			USE (tcdbf) ALIAS (lcAlias) IN 0 AGAIN
		ENDIF
		SELECT (lcAlias)
		IF VARTYPE(tcgrenzen) <> "C"
			lcgrenzen = " .t. "
		ELSE
			lcgrenzen = tcgrenzen
		ENDIF
		LOCATE  FOR &lcgrenzen
		IF FOUND()
			SCATTER MEMO NAME loSatz
		ELSE
			SCATTER MEMO BLANK NAME loSatz
		ENDIF
	ENDIF
SELECT(lnOld_Sel)
RETURN(loSatz)
ENDPROC
